#include <stdio.h>

/* Schaltjahr: Berechnet, ob das angegebene Jahr
 *             ein Schaltjahr war.
 * Parameter:
 *     jahr: Das Kalenderjahr
 * Rckgabewert: 0 ... kein Schaltjahr, 1 ... Schaltjahr
 */
long Schaltjahr(long jahr)
{  // Wie im Schritt zuvor
}  // end Schaltjahr

/* Kalendermonat: Gibt einen Kalendermonat aus
 * Parameter:
 *     anzahlTage: 28 <= anzahlTage <= 31
 *             Anzahl der Tage des Monats
 *     erster: 0=Mo, 1=Di, 2=Mi, 3=Do, 4=Fr, 5=Sa, 6=So
 *             bestimmt Wochentag des ersten Tag des Monats
 * Rckgabewert: Wochentag des 1. des Folgemonats
 *               0=Mo, 1=Di, 2=Mi, 3=Do, 4=Fr, 5=Sa, 6=So
 */
long KalenderMonat(long anzahlTage, long erster)
{  // Wie im Schritt zuvor
}  // end KalenderMonat

/* WochentagErsterJanuar: Ermittelt den Wochentag des
 *                        1. 1. des angegebenen Jahres
 * Parameter:
 *     jahr: > 0
 *            Jahreszahl
 * Rckgabewert: Zahl von 0 bis 6
 *               0=Mo, 1=Di, 2=Mi, 3=Do, 4=Fr, 5=Sa, 6=So
 */
long WochentagErsterJanuar(long jahr)
{  long vorjahr = jahr - 1;

   return (vorjahr * 365 + (vorjahr / 4) -
           (vorjahr / 100) + (vorjahr / 400)) % 7;
}  // end WochentagErsterJanuar

/* KalenderJahr: Gibt ein Kalenderjahr aus
 * Parameter:
 *     jahr: > 0
 *            Jahreszahl
 * Rckgabewert: Keiner
 */
void KalenderJahr(long jahr)
{  long monat, tage, erster;

   printf("Jahr %ld:\n", jahr);

   erster = WochentagErsterJanuar(jahr);

   for (monat = 1; monat <= 12; monat = monat + 1)
   {  switch(monat)
      {case 1:
       case 3:
       case 5:
       case 7:
       case 8:
       case 10:
       case 12:
         tage = 31;
         break;
       case 4:
       case 6:
       case 9:
       case 11:
         tage = 30;
         break;
       case 2:
         if (Schaltjahr(jahr))
            tage = 29;
         else
            tage = 28;
         break;
      }
      printf("Monat %ld:\n", monat);
      erster = KalenderMonat(tage, erster);
   }
}  // end KalenderJahr

main()
{  long jahr;

   // Eingabe
   printf("Welches Jahr: ");
   scanf ("%ld", &jahr);

   // Ausgabe eines Jahres
   printf("\n");
   KalenderJahr(jahr);
}  // end main
